diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index ebba016a8..cf52c9be9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -164,6 +164,7 @@ public abstract class Entity
     public boolean isWalking = false;
     protected boolean muteStepSounds = false;
     public float footSize = 0.0F;
+    public float stepDownSize = 0.0F;
 
     // Tick
     private boolean firstTick = true;
@@ -445,6 +446,7 @@ public abstract class Entity
             this.z = (this.bb.minZ + this.bb.maxZ) / 2.0;
             return;
         }
+        boolean wasOnGround = this.onGround;
         this.ySlideOffset *= 0.4f;
         double d3 = this.x;
         double d4 = this.z;
@@ -608,6 +610,22 @@ public abstract class Entity
                 this.bb.set(workingBox4);
             }
         }
+
+        if (this.stepDownSize > 0.0f
+            && wasOnGround
+            && !isSneaking()
+            && (oldXd != 0.0 || oldZd != 0.0)
+            && yd < 0.0 && oldYd == yd) {
+            double snap = -this.stepDownSize;
+            List<AABBdc> below = this.world.getCubes(this, MathHelper.aabbExpand(this.bb, 0.0, snap, 0.0, workingBox2));
+            for (int i = 0; i < below.size(); i++) {
+                snap = MathHelper.aabbClipYCollide(below.get(i), this.bb, snap);
+            }
+            if (snap > -this.stepDownSize) {
+                this.bb.translate(0.0, snap, 0.0);
+                yd += snap;
+            }
+        }
         //fix for entity jitter when blasted by cannonballs (can cause some client-side jitter when entity is under a ceiling. unsure exactly why)
         if (!this.world.isClientSide || this instanceof Player || !(this instanceof Mob) || this.locallySimulated) {
             this.x = (this.bb.minX + this.bb.maxX) / 2D;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index 552eacf7e..e4b4dd745 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -28,6 +28,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 
 public class EntityItem extends Entity
@@ -35,7 +36,7 @@ public class EntityItem extends Entity
     public ItemStack item;
     public int lifetime;
     public int age;
-    public Direction siphonDirection = Direction.NONE;
+    public @Nullable Direction siphonDirection = null;
     public TileEntityMesh meshSiphoning = null;
     public int pickupDelay;
     private int health;
@@ -459,7 +460,7 @@ public class EntityItem extends Entity
     }
 
     public boolean isBeingSiphoned(){
-        return siphonDirection != Direction.NONE;
+        return siphonDirection != null;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index be0aa4c9a..3bdbf6ee9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -40,6 +40,7 @@ public class MobPig
         super(world);
         setTextureIdentifier("minecraft", "pig");
         setSize(0.9F, 0.9F);
+        this.stepDownSize = 0.5F;
         this.mobDrops.add(new WeightedRandomLootObject(Items.FOOD_PORKCHOP_RAW.getDefaultStack(), 1, 2));
         this.burningMobDrops.add(new WeightedRandomLootObject(Items.FOOD_PORKCHOP_COOKED.getDefaultStack(), 1, 2));
 //        age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 4, 14, MobAge.YEAR_LENGTH_DAYS * 3);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
index 4b5c6377f..74cc5cb67 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobMonster.java
@@ -93,6 +93,7 @@ public abstract class MobMonster extends MobPathfinder
                 return true;
             }
             if (attacker != this) {
+                if (attacker instanceof Player player && !player.gamemode.hasHostileMobs()) return true;
                 this.target = attacker;
             }
             return true;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
index 21a1d54af..bdc2ecc6e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
@@ -55,13 +55,6 @@ public class MobSkeleton extends MobMonsterArmored<HumanArmorShape>
         entityData.define(DATA_ATTACK_TIME, attackTime, Integer.class);
     }
 
-    @Override
-    public void spawnInit() {
-        super.spawnInit();
-
-        setHeldItem(DEFAULT_HELD_ITEM.copy());
-    }
-
     @Override
 	public void onLivingUpdate()
     {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
index 80250b69e..795fc27fd 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
@@ -15,6 +15,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 
 import java.util.ArrayList;
@@ -41,13 +42,6 @@ public class MobZombiePig extends MobZombie {
         this.scoreValue = 500;
     }
 
-    @Override
-    public void spawnInit() {
-        super.spawnInit();
-
-        setHeldItem(DEFAULT_HELD_ITEM.copy());
-    }
-
     @Override
     public void tick() {
         if (this.tickCount % 200 == 0 && this.target instanceof Player && ((Player) this.target).getStat(Achievements.MOST_WANTED) <= 0) {
@@ -173,4 +167,9 @@ public class MobZombiePig extends MobZombie {
     public boolean hurtByNetherWater() {
         return false;
     }
+
+    @Override
+    public @Nullable ItemStack getHeldItem() {
+        return DEFAULT_HELD_ITEM;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index d7dc626da..d77fea5ab 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -180,7 +180,9 @@ public abstract class Player
 
     protected void setupScale() {
         this.isDwarf = this.world.getGameRuleValue(GameRules.DWARF_MODE);
-        if (this.isDwarf) {
+        if (this.sleeping) {
+            setSize(0.2f, 0.2f);
+        } else if (this.isDwarf) {
             setSize(0.6f, isSneaking() ? 0.5f : 0.8f);
         } else {
             setSize(0.6f, isSneaking() ? 1.5f : 1.8f);
@@ -1268,9 +1270,9 @@ public abstract class Player
                 damage++;
             }
             boolean wasAlive = entity.isAlive();
-            entity.hurt(this, damage, DamageType.COMBAT);
+            boolean damageDealt = entity.hurt(this, damage, DamageType.COMBAT);
             ItemStack itemstack = getCurrentEquippedItem();
-            if (itemstack != null && (entity instanceof Mob) && wasAlive) {
+            if (damageDealt && itemstack != null && (entity instanceof Mob) && wasAlive) {
                 itemstack.hitEntity((Mob) entity, this);
                 if (itemstack.stackSize <= 0) {
                     destroyCurrentEquippedItem();
@@ -1350,23 +1352,23 @@ public abstract class Player
         if (this.world.isBlockLoaded(x, y, z)) {
             int meta = this.world.getBlockMetadata(x, y, z);
             int dir = BlockLogicBed.DIRECTION.get(meta);
-            float xOff = 0.5F;
-            float zOff = 0.5F;
+            double xOff = 0.5D;
+            double zOff = 0.5D;
 
             if (dir == 0) {
-                zOff = 0.9f;
+                zOff = 0.9D;
             } else if (dir == 1) {
-                xOff = 0.1f;
+                xOff = 0.1D;
             } else if (dir == 2) {
-                zOff = 0.1f;
+                zOff = 0.1D;
             } else if (dir == 3) {
-                xOff = 0.9f;
+                xOff = 0.9D;
             }
 
             func_22052_e(dir);
-            setPos(x + xOff, y + 0.9375F, z + zOff);
+            setPos(x + xOff, y + 0.9375D, z + zOff);
         } else {
-            setPos(x + 0.5F, y + 0.9375F, z + 0.5F);
+            setPos(x + 0.5D, y + 0.9375D, z + 0.5D);
         }
         this.sleeping = true;
         this.sleepTimer = 0;
@@ -1401,6 +1403,8 @@ public abstract class Player
     }
 
     public void wakeUpPlayer(boolean flag, boolean flag1) {
+        // Cleared before setupScale so the standing hitbox is restored for the setPos below
+        this.sleeping = false;
         setupScale();
         TilePos bedPos = this.bedTilePos;
         Block<?> b;
@@ -1411,9 +1415,8 @@ public abstract class Player
             if (emptyPos == null) {
                 emptyPos = bedPos.up(new TilePos());
             }
-            setPos((float) emptyPos.x + 0.5F, (float) emptyPos.y + this.heightOffset + 0.1F, (float) emptyPos.z + 0.5F);
+            setPos(emptyPos.x + 0.5D, emptyPos.y + (double) this.heightOffset + 0.1D, emptyPos.z + 0.5D);
         }
-        this.sleeping = false;
         if (!this.world.isClientSide && flag1) {
             this.world.updateEnoughPlayersSleepingFlag(this);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
index 4a3831aa0..b2a2a3b9d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemLabel.java
@@ -4,6 +4,7 @@ import com.b100.utils.StringUtils;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
@@ -23,6 +24,11 @@ public class ItemLabel extends Item {
         setMaxStackSize(1);
     }
 
+    @Override
+    public boolean interactsWithEntity(@NotNull ItemStack selfStack, @NotNull Entity entity) {
+        return super.interactsWithEntity(selfStack, entity) || entity instanceof MobButterfly;
+    }
+
     @Override
     public @Nullable ItemStack onUse(final @NotNull ItemStack selfStack, final @NotNull World world, final @NotNull Player player) {
         if (selfStack.hasCustomName()) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java
index 3e0999e68..45116aa20 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandNBT.java
@@ -2,7 +2,10 @@ package net.minecraft.core.item;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.MobButterfly;
+import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.util.helper.Side;
@@ -17,6 +20,11 @@ public class ItemWandNBT extends Item{
         super(translationKey, namespaceId, id);
     }
 
+    @Override
+    public boolean interactsWithEntity(@NotNull ItemStack selfStack, @NotNull Entity entity) {
+        return super.interactsWithEntity(selfStack, entity) || entity instanceof MobButterfly || entity instanceof MobFireflyCluster;
+    }
+
     @Override
     public ItemStack onInventoryInteract(@NotNull Player player, @NotNull Slot slot, @Nullable ItemStack stackInSlot, boolean isItemGrabbed) {
         if (slot.getItemStack() != null) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java
index 030363c7b..5b4410d79 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolPickaxe.java
@@ -16,7 +16,6 @@ public class ItemToolPickaxe extends ItemTool {
 	
 	static {
 		miningLevels.put(Blocks.OBSIDIAN, 3);
-		miningLevels.put(Blocks.LOG_PETRIFIED, 3);
 		
 		miningLevels.put(Blocks.BLOCK_DIAMOND, 2);
 		miningLevels.put(Blocks.ORE_DIAMOND_STONE, 2);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
index cc2f87441..982e2fd4b 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
@@ -12,6 +12,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.arguments.ArgumentTypeAchievement;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import org.jetbrains.annotations.NotNull;
@@ -38,7 +39,7 @@ public class CommandAchievement implements CommandManager.CommandRegistry {
                         }
 
                         grantAchievements(player, collectWithAncestors(achievement));
-                        source.sendTranslatableMessage("command.commands.achievement.grant.success_single_entity", achievement.getStatName().trim(), player.getDisplayName());
+                        source.sendTranslatableMessage("command.commands.achievement.grant.success_single_entity", achievement.getStatName().trim(), TextFormatting.scoped(player.getDisplayName()));
 
                         return Command.SINGLE_SUCCESS;
                     }))
@@ -51,7 +52,7 @@ public class CommandAchievement implements CommandManager.CommandRegistry {
                             grantAchievements(player, collectWithAncestors(achievement));
                         }
 
-                        source.sendTranslatableMessage("command.commands.achievement.grant.all.success_single_entity", player.getDisplayName());
+                        source.sendTranslatableMessage("command.commands.achievement.grant.all.success_single_entity", TextFormatting.scoped(player.getDisplayName()));
 
                         return Command.SINGLE_SUCCESS;
                     })))
@@ -63,7 +64,7 @@ public class CommandAchievement implements CommandManager.CommandRegistry {
                         Achievement achievement = c.getArgument("achievement", Achievement.class);
 
                         revokeAchievements(player, collectWithDescendants(achievement));
-                        source.sendTranslatableMessage("command.commands.achievement.revoke.success_single_entity", achievement.getStatName().trim(), player.getDisplayName());
+                        source.sendTranslatableMessage("command.commands.achievement.revoke.success_single_entity", achievement.getStatName().trim(), TextFormatting.scoped(player.getDisplayName()));
 
                         return Command.SINGLE_SUCCESS;
                     }))
@@ -73,7 +74,7 @@ public class CommandAchievement implements CommandManager.CommandRegistry {
                         Player player = requireSender(source);
 
                         revokeAchievements(player, collectAllAchievementsByDepthDesc());
-                        source.sendTranslatableMessage("command.commands.achievement.revoke.all.success_single_entity", player.getDisplayName());
+                        source.sendTranslatableMessage("command.commands.achievement.revoke.all.success_single_entity", TextFormatting.scoped(player.getDisplayName()));
 
                         return Command.SINGLE_SUCCESS;
                     })))));
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandKill.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandKill.java
index d3dce5ee7..dcd42795a 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandKill.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandKill.java
@@ -12,6 +12,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.command.helpers.EntitySelector;
@@ -32,7 +33,7 @@ public class CommandKill implements CommandManager.CommandRegistry {
 
                     sender.killPlayer();
 
-                    source.sendTranslatableMessage("command.commands.kill.single_entity", sender.getDisplayName());
+                    source.sendTranslatableMessage("command.commands.kill.single_entity", TextFormatting.scoped(sender.getDisplayName()));
 
                     return Command.SINGLE_SUCCESS;
                 })
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
index 171d645df..4709551af 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
@@ -11,6 +11,7 @@ import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.arguments.ArgumentTypeDimension;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.arguments.ArgumentTypeVector3d;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
@@ -34,7 +35,7 @@ public class CommandTeleport implements CommandManager.CommandRegistry {
                             if (source.getSender() != null) {
                                 source.movePlayerToDimension(source.getSender(), dimension.id);
                                 source.teleportPlayerToPos(source.getSender(), targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
-                                source.sendTranslatableMessage("command.commands.teleport.dimension_location.success_single_entity", source.getSender().getDisplayName(), dimension.languageKey, targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
+                                source.sendTranslatableMessage("command.commands.teleport.dimension_location.success_single_entity", TextFormatting.scoped(source.getSender().getDisplayName()), dimension.languageKey, targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
                             } else {
                                 throw CommandExceptions.notInWorld().create();
                             }
@@ -47,7 +48,7 @@ public class CommandTeleport implements CommandManager.CommandRegistry {
 
                         if (source.getSender() != null) {
                             source.movePlayerToDimension(source.getSender(), dimension.id);
-                            source.sendTranslatableMessage("command.commands.teleport.dimension.success_single_entity", source.getSender().getDisplayName(), dimension.languageKey);
+                            source.sendTranslatableMessage("command.commands.teleport.dimension.success_single_entity", TextFormatting.scoped(source.getSender().getDisplayName()), dimension.languageKey);
                         } else {
                             throw CommandExceptions.notInWorld().create();
                         }
@@ -62,7 +63,7 @@ public class CommandTeleport implements CommandManager.CommandRegistry {
 
                             if (source.getSender() != null) {
                                 source.teleportPlayerToPos(source.getSender(), targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
-                                source.sendTranslatableMessage("command.commands.teleport.location.success_single_entity", source.getSender().getDisplayName(), targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
+                                source.sendTranslatableMessage("command.commands.teleport.location.success_single_entity", TextFormatting.scoped(source.getSender().getDisplayName()), targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
                             } else {
                                 throw CommandExceptions.notInWorld().create();
                             }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java b/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
index 00c9503b1..2592309e7 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/util/CommandHelper.java
@@ -10,6 +10,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.helpers.IntegerCoordinates;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
@@ -102,7 +103,7 @@ public class CommandHelper {
     }
 
     public static String getEntityName(Entity entity) {
-        return Entity.getNameFromEntity(entity, true);
+        return TextFormatting.scoped(Entity.getNameFromEntity(entity, true));
     }
 
     public static int getVolume(CommandSource source, IntegerCoordinates first, IntegerCoordinates second) throws CommandSyntaxException {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
index fde062915..ee8b0f514 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/CreativeMenuContents.java
@@ -207,8 +207,7 @@ public final class CreativeMenuContents {
 
 		list.add(new ItemStack(Items.HANDCANNON_UNLOADED));
 		list.add(new ItemStack(Items.AMMO_CHARGE_EXPLOSIVE));
-		list.add(new ItemStack(Items.AMMO_FIREBALL));
-		addGap(list, 2);
+		addGap(list, 3);
 		list.add(new ItemStack(Items.TOOL_CALENDAR));
 		newLine(list);
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/world/LevelListener.java b/game/core/src/main/java/net/minecraft/core/world/LevelListener.java
index 96a6e15e7..deb4521fd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/game/core/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -66,6 +66,10 @@ public interface LevelListener
      * data: unused
      */
     int EVENT_ACID_SPREAD = 1010;
+    /**
+     * data: the {@link net.minecraft.core.util.helper.Direction} id of the mesh's open water face
+     */
+    int EVENT_MESH_SIPHON_PARTICLES = 1011;
 
 	/**
 	 * Redraw block in singleplayer and send block change packet in multiplayer. <br>
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java
index 191d15527..17a83e367 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeThorn.java
@@ -8,14 +8,17 @@ import java.util.ArrayList;
 import java.util.List;
 
 public class WorldFeatureTreeThorn extends WorldFeatureSpoonerTreeProcedural {
+    private final int baseHeight;
+
     @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureTreeThorn(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
+        this.baseHeight = height;
     }
 
     @Override
     protected void prepare(World world) {
-        this.height = height + random.nextInt(3);
+        this.height = baseHeight + random.nextInt(3);
         this.foliageShape = new double[] { 4.5, 3.5, 2 };
         this.branchSlope = 1;
         this.trunkRadius = 1;
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
index d97a06674..3bc1b04c6 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
@@ -320,6 +320,7 @@ gui.options.hudeditor.snap_to_fill=Snap To Fill
 gui.options.hudeditor.scale=GUI Scale
 gui.options.hudeditor.chat_width=Chat Width
 gui.options.hudeditor.chat_height=Chat Height
+gui.options.hudeditor.chat_full_width_backdrop=Full Width Chat Backdrop
 
 gui.sound_test.label.title=Sound Test
 gui.sound_test.label.repo=Sound Repository: %s
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index 3d3aab87e..385f139a7 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -470,7 +470,12 @@ public class PlayerServer extends Player implements ContainerListener {
         if (isPlayerSleeping())
         {
             EntityTrackerImpl entitytracker = mcServer.getEntityTracker(dimension);
-            entitytracker.sendPacketToTrackedPlayersAndTrackedEntity(this, new PacketAnimate(this, 3));
+            PacketAnimate wakePacket = new PacketAnimate(this, 3);
+            entitytracker.sendPacketToTrackedPlayers(this, wakePacket);
+            if (playerNetServerHandler != null)
+            {
+                playerNetServerHandler.sendPacket(wakePacket);
+            }
             super.wakeUpPlayer(flag, flag1);
         }
         if (playerNetServerHandler != null)
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index f9368fbc7..7c8f7725f 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -558,8 +558,9 @@ public class PacketHandlerServer extends PacketHandler
             }
             case PacketUpdatePlayerState.STATE_UN_SNEAK -> this.playerEntity.setSneaking(false);
             case PacketUpdatePlayerState.STATE_LEAVE_BED -> {
-                this.playerEntity.wakeUpPlayer(false, true);
-                this.hasMoved = false;
+                if (this.playerEntity.isPlayerSleeping()) {
+                    this.playerEntity.wakeUpPlayer(false, true);
+                }
             }
             case PacketUpdatePlayerState.STATE_NO_CLIP -> {
                 this.playerEntity.setNoclip(true);
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 216a26b2b..7e2f79cc2 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -135,8 +135,6 @@ public class WorldServer extends World {
 
         send_message: {
             if (MinecraftServer.getInstance() == null) break send_message;
-            if (players.size() <= 1) break send_message;
-            if (this.getPlayersRequiredToSkipNight() <= 1) break send_message;
 
             Player sleeper = null;
             for (final var p : players) {
